[Lucid] Prepare virtual flavour to be usable for EC2

Bug #1177431 reported by Stefan Bader on 2013-05-07
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Wishlist
Unassigned
Lucid
Wishlist
Stefan Bader

Bug Description

SRU Justification:

Impact:
Currently we ship a specially patched kernel in Lucid for EC2. This was due to a bug in the upstream kernel that caused the guest to crash when certain cpu features were available. This bug has been fixed upstream and in the Lucid kernel [1]. Since carrying that specially patched kernel causes more maintenance burden and may result in undetected security issues we should replace that kernel with the virtual flavour kernel (derived from server / generic-pae).

Fix:
Change Xen specific drivers to be built-in (as in the ec2 kernel now). Those drivers will not be used when not running under Xen and are therefore safe to have. They need to be built-in as they are not auto-probed. When all preparations are done, we will change the linux-meta-ec2 package to pull in the virtual binary package.

Testcase:
Replace the ec2 kernel by the virtual kernel on a ec2 system (depends on bug #1176159).

[1] commit cb72b3759fe5621613954eb5228dfaedb3c2a555
Author: Shan Haitao <email address hidden>
Date: Fri Sep 21 17:28:04 2012 +0200

    xen: Allow PV-OPS kernel to detect whether XSAVE is supported

Stefan Bader (smb) on 2013-05-07
Changed in linux (Ubuntu Lucid):
status: New → In Progress
importance: Undecided → Wishlist
assignee: nobody → Stefan Bader (stefan-bader-canonical)
Changed in linux (Ubuntu):
status: In Progress → Invalid
assignee: Stefan Bader (stefan-bader-canonical) → nobody
Stefan Bader (smb) wrote :

The EC2 kernel also had this revert applied:

Author: John Johansen <email address hidden>
Date: Fri Aug 20 10:16:53 2010 -0700

    UBUNTU: SAUCE: Revert "sched: update load count only once per cpu in 10 tick

    BugLink: http://bugs.launchpad.net/bugs/574910

The final fix for that would be those two patches below. But as the ec2 problem only was caused by the fact that those kernels were not tickless, we should wait for real issues with the replacing kernels being tickless. The revert plus the two other patches were upstream in Karmic and later but we never had good reproducers.

Author: Peter Zijlstra <email address hidden>
Date: Thu Apr 22 21:50:19 2010 +0200

    sched: Cure load average vs NO_HZ woes

Author: Peter Zijlstra <email address hidden>
Date: Tue Nov 30 19:48:45 2010 +0100

    sched: Cure more NO_HZ load average woes

Stefan Bader (smb) wrote :

One more patch should go into the tree for Xen. This has been upstream and in stable but there has not yet been a newer stable release for 3.2:

commit a93368d631f76abe4e0bf17fb80ae35660e608ed
Author: Stefan Bader <email address hidden>
Date: Fri Feb 15 09:48:52 2013 +0100

    SAUCE: xen: Send spinlock IPI to all waiters

Stefan Bader (smb) on 2013-05-09
Changed in linux (Ubuntu Lucid):
status: In Progress → Fix Committed
Brad Figg (brad-figg) wrote :

This bug is awaiting verification that the kernel in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed' to 'verification-done'.

If verification is not done by one week from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-lucid
Stefan Bader (smb) wrote :

Replaced the EC2 kernels in lucid cloud-images on Xen by the virtual image and ran some tests. Looks good.

tags: added: verification-done-lucid
removed: verification-needed-lucid

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 2.6.32-48.110

---------------
linux (2.6.32-48.110) lucid; urgency=low

  [Steve Conklin]

  * Release Tracking Bug
    - LP: #1186340

  [ Stefan Bader ]

  * (config) Import Xen specific config options from ec2
    - LP: #1177431
  * SAUCE: xen: Send spinlock IPI to all waiters
    - LP: #1011792, #1177431

  [ Upstream Kernel Changes ]

  * ax25: fix info leak via msg_name in ax25_recvmsg()
    - LP: #1172366
    - CVE-2013-3223
  * Bluetooth: fix possible info leak in bt_sock_recvmsg()
    - LP: #1172368
    - CVE-2013-3224
  * tipc: fix info leaks via msg_name in recv_msg/recv_stream
    - LP: #1172403
    - CVE-2013-3235
  * rose: fix info leak via msg_name in rose_recvmsg()
    - LP: #1172394
    - CVE-2013-3234
  * Bluetooth: RFCOMM - Fix missing msg_namelen update in
    rfcomm_sock_recvmsg()
    - LP: #1172369
    - CVE-2013-3225
  * atm: update msg_namelen in vcc_recvmsg()
    - LP: #1172365
    - CVE-2013-3222
  * KVM: Fix bounds checking in ioapic indirect register reads
    (CVE-2013-1798)
    - LP: #1158262
    - CVE-2013-1798
  * llc: Fix missing msg_namelen update in llc_ui_recvmsg()
    - LP: #1172385
    - CVE-2013-3231
  * netrom: fix info leak via msg_name in nr_recvmsg()
    - LP: #1172386
    - CVE-2013-3232
  * irda: Fix missing msg_namelen update in irda_recvmsg_dgram()
    - LP: #1172380
    - CVE-2013-3228
  * iucv: Fix missing msg_namelen update in iucv_sock_recvmsg()
    - LP: #1172381
    - CVE-2013-3229
 -- Steve Conklin <email address hidden> Fri, 31 May 2013 12:03:46 -0500

Changed in linux (Ubuntu Lucid):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers